﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace DataValueChanged
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private StockPortfolioData _stockPortfolioData = new StockPortfolioData(200);

        private void Window_Loaded_1(object sender, RoutedEventArgs e)
        {
            if (myDataGrid.DataSource == null)
                this.myDataGrid.DataSource = this._stockPortfolioData.Data;

            this._stockPortfolioData.StartUpdatingData();
        }

        private void Window_Unloaded_1(object sender, RoutedEventArgs e)
        {
            this._stockPortfolioData.StopUpdatingData();
        }

        public MainWindow()
        {
            InitializeComponent();
        }

        private void myDataGrid_DataValueChanged_1(object sender, Infragistics.Windows.DataPresenter.Events.DataValueChangedEventArgs e)
        {
            if (e.ValueHistory == null)
            {
                e.CellValuePresenter.ClearValue(CellValuePresenter.StyleProperty);
            }
            else
                if (e.CellValuePresenter != null && e.ValueHistory.Count > 1)
                {
                    DataValueInfo latestDataValueInfo = e.ValueHistory[0];
                    DataValueInfo previousDataValueInfo = e.ValueHistory[1];

                    if ((double)latestDataValueInfo.Value < (double)previousDataValueInfo.Value)
                    {
                        e.CellValuePresenter.Style = this.Resources["SadSmiley"] as Style;
                    }
                    else
                        if ((double)latestDataValueInfo.Value > (double)previousDataValueInfo.Value)
                        {
                            e.CellValuePresenter.Style = this.Resources["SmilingSmiley"] as Style;
                        }
                        else
                          e.CellValuePresenter.Background = Brushes.Cyan;
                }
        }
    }
}
